package jp.sourceforge.freegantt.print;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.UIManager;

import jp.sourceforge.freegantt.locale.Resource;
import jp.sourceforge.freegantt.swing.Application;

public class PreviewMenu extends JMenuBar {
	private static final long serialVersionUID = 6042448557260023987L;

	Application app;
	PreviewDialog dialog;
	
	public PreviewMenu(final Application app, final PreviewDialog dialog) {
		this.app = app;
		this.dialog = dialog;
		
		Font font = getFont();
		Font newFont = new Font(font.getName(), 0, font.getSize());
		UIManager.put("Menu.font", newFont);
		UIManager.put("MenuItem.font", newFont);
		UIManager.put("MenuItem.acceleratorFont", newFont);
		UIManager.put("MenuItem.acceleratorForeground", Color.gray);

		JMenu menu = new JMenu(Resource.get("menuFile"));
		JMenuItem item = new JMenuItem(Resource.get("menuFilePage"));
		item.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent e) {
				app.configurePage();
				dialog.updatePageFormat(app.getProject().getPrint().getPageFormat());
				dialog.renderPage(dialog.getPage());
			}
		});
		menu.add(item);
		item = new JMenuItem(Resource.get("menuFilePrint"));
		item.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent e) {
				app.print();
			}
		});
		menu.add(item);
		add(menu);
		
	}

}
